/*
 * Generated by gdbus-codegen 2.53.5. DO NOT EDIT.
 *
 * The license of this code is the same as for the source it was derived from.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "cc-shell-search-provider-generated.h"

#include <string.h>
#ifdef G_OS_UNIX
#  include <gio/gunixfdlist.h>
#endif

typedef struct
{
  GDBusArgInfo parent_struct;
  gboolean use_gvariant;
} _ExtendedGDBusArgInfo;

typedef struct
{
  GDBusMethodInfo parent_struct;
  const gchar *signal_name;
  gboolean pass_fdlist;
} _ExtendedGDBusMethodInfo;

typedef struct
{
  GDBusSignalInfo parent_struct;
  const gchar *signal_name;
} _ExtendedGDBusSignalInfo;

typedef struct
{
  GDBusPropertyInfo parent_struct;
  const gchar *hyphen_name;
  gboolean use_gvariant;
} _ExtendedGDBusPropertyInfo;

typedef struct
{
  GDBusInterfaceInfo parent_struct;
  const gchar *hyphen_name;
} _ExtendedGDBusInterfaceInfo;

typedef struct
{
  const _ExtendedGDBusPropertyInfo *info;
  guint prop_id;
  GValue orig_value; /* the value before the change */
} ChangedProperty;

static void
_changed_property_free (ChangedProperty *data)
{
  g_value_unset (&data->orig_value);
  g_free (data);
}

static gboolean
_g_strv_equal0 (gchar **a, gchar **b)
{
  gboolean ret = FALSE;
  guint n;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  if (g_strv_length (a) != g_strv_length (b))
    goto out;
  for (n = 0; a[n] != NULL; n++)
    if (g_strcmp0 (a[n], b[n]) != 0)
      goto out;
  ret = TRUE;
out:
  return ret;
}

static gboolean
_g_variant_equal0 (GVariant *a, GVariant *b)
{
  gboolean ret = FALSE;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  ret = g_variant_equal (a, b);
out:
  return ret;
}

G_GNUC_UNUSED static gboolean
_g_value_equal (const GValue *a, const GValue *b)
{
  gboolean ret = FALSE;
  g_assert (G_VALUE_TYPE (a) == G_VALUE_TYPE (b));
  switch (G_VALUE_TYPE (a))
    {
      case G_TYPE_BOOLEAN:
        ret = (g_value_get_boolean (a) == g_value_get_boolean (b));
        break;
      case G_TYPE_UCHAR:
        ret = (g_value_get_uchar (a) == g_value_get_uchar (b));
        break;
      case G_TYPE_INT:
        ret = (g_value_get_int (a) == g_value_get_int (b));
        break;
      case G_TYPE_UINT:
        ret = (g_value_get_uint (a) == g_value_get_uint (b));
        break;
      case G_TYPE_INT64:
        ret = (g_value_get_int64 (a) == g_value_get_int64 (b));
        break;
      case G_TYPE_UINT64:
        ret = (g_value_get_uint64 (a) == g_value_get_uint64 (b));
        break;
      case G_TYPE_DOUBLE:
        {
          /* Avoid -Wfloat-equal warnings by doing a direct bit compare */
          gdouble da = g_value_get_double (a);
          gdouble db = g_value_get_double (b);
          ret = memcmp (&da, &db, sizeof (gdouble)) == 0;
        }
        break;
      case G_TYPE_STRING:
        ret = (g_strcmp0 (g_value_get_string (a), g_value_get_string (b)) == 0);
        break;
      case G_TYPE_VARIANT:
        ret = _g_variant_equal0 (g_value_get_variant (a), g_value_get_variant (b));
        break;
      default:
        if (G_VALUE_TYPE (a) == G_TYPE_STRV)
          ret = _g_strv_equal0 (g_value_get_boxed (a), g_value_get_boxed (b));
        else
          g_critical ("_g_value_equal() does not handle type %s", g_type_name (G_VALUE_TYPE (a)));
        break;
    }
  return ret;
}

/* ------------------------------------------------------------------------
 * Code for interface org.gnome.Shell.SearchProvider2
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:CcShellSearchProvider2
 * @title: CcShellSearchProvider2
 * @short_description: Generated C code for the org.gnome.Shell.SearchProvider2 D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.gnome.Shell.SearchProvider2 ---- */

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_initial_result_set_IN_ARG_terms =
{
  {
    -1,
    (gchar *) "terms",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_initial_result_set_IN_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_initial_result_set_IN_ARG_terms,
  NULL
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_initial_result_set_OUT_ARG_results =
{
  {
    -1,
    (gchar *) "results",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_initial_result_set_OUT_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_initial_result_set_OUT_ARG_results,
  NULL
};

static const _ExtendedGDBusMethodInfo _cc_shell_search_provider2_method_info_get_initial_result_set =
{
  {
    -1,
    (gchar *) "GetInitialResultSet",
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_initial_result_set_IN_ARG_pointers,
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_initial_result_set_OUT_ARG_pointers,
    NULL
  },
  "handle-get-initial-result-set",
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_previous_results =
{
  {
    -1,
    (gchar *) "previous_results",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_terms =
{
  {
    -1,
    (gchar *) "terms",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_previous_results,
  &_cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_terms,
  NULL
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_subsearch_result_set_OUT_ARG_results =
{
  {
    -1,
    (gchar *) "results",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_subsearch_result_set_OUT_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_subsearch_result_set_OUT_ARG_results,
  NULL
};

static const _ExtendedGDBusMethodInfo _cc_shell_search_provider2_method_info_get_subsearch_result_set =
{
  {
    -1,
    (gchar *) "GetSubsearchResultSet",
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_subsearch_result_set_IN_ARG_pointers,
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_subsearch_result_set_OUT_ARG_pointers,
    NULL
  },
  "handle-get-subsearch-result-set",
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_result_metas_IN_ARG_identifiers =
{
  {
    -1,
    (gchar *) "identifiers",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_result_metas_IN_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_result_metas_IN_ARG_identifiers,
  NULL
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_get_result_metas_OUT_ARG_metas =
{
  {
    -1,
    (gchar *) "metas",
    (gchar *) "aa{sv}",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_get_result_metas_OUT_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_result_metas_OUT_ARG_metas,
  NULL
};

static const _ExtendedGDBusMethodInfo _cc_shell_search_provider2_method_info_get_result_metas =
{
  {
    -1,
    (gchar *) "GetResultMetas",
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_result_metas_IN_ARG_pointers,
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_get_result_metas_OUT_ARG_pointers,
    NULL
  },
  "handle-get-result-metas",
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_activate_result_IN_ARG_identifier =
{
  {
    -1,
    (gchar *) "identifier",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_activate_result_IN_ARG_terms =
{
  {
    -1,
    (gchar *) "terms",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_activate_result_IN_ARG_timestamp =
{
  {
    -1,
    (gchar *) "timestamp",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_activate_result_IN_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_activate_result_IN_ARG_identifier,
  &_cc_shell_search_provider2_method_info_activate_result_IN_ARG_terms,
  &_cc_shell_search_provider2_method_info_activate_result_IN_ARG_timestamp,
  NULL
};

static const _ExtendedGDBusMethodInfo _cc_shell_search_provider2_method_info_activate_result =
{
  {
    -1,
    (gchar *) "ActivateResult",
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_activate_result_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-activate-result",
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_launch_search_IN_ARG_terms =
{
  {
    -1,
    (gchar *) "terms",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _cc_shell_search_provider2_method_info_launch_search_IN_ARG_timestamp =
{
  {
    -1,
    (gchar *) "timestamp",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo * const _cc_shell_search_provider2_method_info_launch_search_IN_ARG_pointers[] =
{
  &_cc_shell_search_provider2_method_info_launch_search_IN_ARG_terms,
  &_cc_shell_search_provider2_method_info_launch_search_IN_ARG_timestamp,
  NULL
};

static const _ExtendedGDBusMethodInfo _cc_shell_search_provider2_method_info_launch_search =
{
  {
    -1,
    (gchar *) "LaunchSearch",
    (GDBusArgInfo **) &_cc_shell_search_provider2_method_info_launch_search_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-launch-search",
  FALSE
};

static const _ExtendedGDBusMethodInfo * const _cc_shell_search_provider2_method_info_pointers[] =
{
  &_cc_shell_search_provider2_method_info_get_initial_result_set,
  &_cc_shell_search_provider2_method_info_get_subsearch_result_set,
  &_cc_shell_search_provider2_method_info_get_result_metas,
  &_cc_shell_search_provider2_method_info_activate_result,
  &_cc_shell_search_provider2_method_info_launch_search,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _cc_shell_search_provider2_interface_info =
{
  {
    -1,
    (gchar *) "org.gnome.Shell.SearchProvider2",
    (GDBusMethodInfo **) &_cc_shell_search_provider2_method_info_pointers,
    NULL,
    NULL,
    NULL
  },
  "shell-search-provider2",
};


/**
 * cc_shell_search_provider2_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
cc_shell_search_provider2_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct;
}

/**
 * cc_shell_search_provider2_override_properties:
 * @klass: The class structure for a #GObject<!-- -->-derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #CcShellSearchProvider2 interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
cc_shell_search_provider2_override_properties (GObjectClass *klass, guint property_id_begin)
{
  return property_id_begin - 1;
}



/**
 * CcShellSearchProvider2:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link>.
 */

/**
 * CcShellSearchProvider2Iface:
 * @parent_iface: The parent interface.
 * @handle_activate_result: Handler for the #CcShellSearchProvider2::handle-activate-result signal.
 * @handle_get_initial_result_set: Handler for the #CcShellSearchProvider2::handle-get-initial-result-set signal.
 * @handle_get_result_metas: Handler for the #CcShellSearchProvider2::handle-get-result-metas signal.
 * @handle_get_subsearch_result_set: Handler for the #CcShellSearchProvider2::handle-get-subsearch-result-set signal.
 * @handle_launch_search: Handler for the #CcShellSearchProvider2::handle-launch-search signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link>.
 */

typedef CcShellSearchProvider2Iface CcShellSearchProvider2Interface;
G_DEFINE_INTERFACE (CcShellSearchProvider2, cc_shell_search_provider2, G_TYPE_OBJECT)

static void
cc_shell_search_provider2_default_init (CcShellSearchProvider2Iface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * CcShellSearchProvider2::handle-get-initial-result-set:
   * @object: A #CcShellSearchProvider2.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_terms: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetInitialResultSet">GetInitialResultSet()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call cc_shell_search_provider2_complete_get_initial_result_set() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %TRUE if the invocation was handled, %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-initial-result-set",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (CcShellSearchProvider2Iface, handle_get_initial_result_set),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRV);

  /**
   * CcShellSearchProvider2::handle-get-subsearch-result-set:
   * @object: A #CcShellSearchProvider2.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_previous_results: Argument passed by remote caller.
   * @arg_terms: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetSubsearchResultSet">GetSubsearchResultSet()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call cc_shell_search_provider2_complete_get_subsearch_result_set() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %TRUE if the invocation was handled, %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-subsearch-result-set",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (CcShellSearchProvider2Iface, handle_get_subsearch_result_set),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRV, G_TYPE_STRV);

  /**
   * CcShellSearchProvider2::handle-get-result-metas:
   * @object: A #CcShellSearchProvider2.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_identifiers: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetResultMetas">GetResultMetas()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call cc_shell_search_provider2_complete_get_result_metas() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %TRUE if the invocation was handled, %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-get-result-metas",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (CcShellSearchProvider2Iface, handle_get_result_metas),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRV);

  /**
   * CcShellSearchProvider2::handle-activate-result:
   * @object: A #CcShellSearchProvider2.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_identifier: Argument passed by remote caller.
   * @arg_terms: Argument passed by remote caller.
   * @arg_timestamp: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.ActivateResult">ActivateResult()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call cc_shell_search_provider2_complete_activate_result() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %TRUE if the invocation was handled, %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-activate-result",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (CcShellSearchProvider2Iface, handle_activate_result),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    4,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRV, G_TYPE_UINT);

  /**
   * CcShellSearchProvider2::handle-launch-search:
   * @object: A #CcShellSearchProvider2.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_terms: Argument passed by remote caller.
   * @arg_timestamp: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.LaunchSearch">LaunchSearch()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call cc_shell_search_provider2_complete_launch_search() or e.g. g_dbus_method_invocation_return_error() on it) and no order signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %TRUE if the invocation was handled, %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-launch-search",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (CcShellSearchProvider2Iface, handle_launch_search),
    g_signal_accumulator_true_handled,
    NULL,
    g_cclosure_marshal_generic,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRV, G_TYPE_UINT);

}

/**
 * cc_shell_search_provider2_call_get_initial_result_set:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_terms: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetInitialResultSet">GetInitialResultSet()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_call_get_initial_result_set_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_call_get_initial_result_set_sync() for the synchronous, blocking version of this method.
 */
void
cc_shell_search_provider2_call_get_initial_result_set (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_terms,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "GetInitialResultSet",
    g_variant_new ("(^as)",
                   arg_terms),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * cc_shell_search_provider2_call_get_initial_result_set_finish:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @out_results: (out): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_call_get_initial_result_set().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with cc_shell_search_provider2_call_get_initial_result_set().
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_initial_result_set_finish (
    CcShellSearchProvider2 *proxy,
    gchar ***out_results,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(^as)",
                 out_results);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_get_initial_result_set_sync:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_terms: Argument to pass with the method invocation.
 * @out_results: (out): Return location for return parameter or %NULL to ignore.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetInitialResultSet">GetInitialResultSet()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_call_get_initial_result_set() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_initial_result_set_sync (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_terms,
    gchar ***out_results,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "GetInitialResultSet",
    g_variant_new ("(^as)",
                   arg_terms),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(^as)",
                 out_results);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_get_subsearch_result_set:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_previous_results: Argument to pass with the method invocation.
 * @arg_terms: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetSubsearchResultSet">GetSubsearchResultSet()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_call_get_subsearch_result_set_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_call_get_subsearch_result_set_sync() for the synchronous, blocking version of this method.
 */
void
cc_shell_search_provider2_call_get_subsearch_result_set (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_previous_results,
    const gchar *const *arg_terms,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "GetSubsearchResultSet",
    g_variant_new ("(^as^as)",
                   arg_previous_results,
                   arg_terms),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * cc_shell_search_provider2_call_get_subsearch_result_set_finish:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @out_results: (out): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_call_get_subsearch_result_set().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with cc_shell_search_provider2_call_get_subsearch_result_set().
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_subsearch_result_set_finish (
    CcShellSearchProvider2 *proxy,
    gchar ***out_results,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(^as)",
                 out_results);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_get_subsearch_result_set_sync:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_previous_results: Argument to pass with the method invocation.
 * @arg_terms: Argument to pass with the method invocation.
 * @out_results: (out): Return location for return parameter or %NULL to ignore.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetSubsearchResultSet">GetSubsearchResultSet()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_call_get_subsearch_result_set() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_subsearch_result_set_sync (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_previous_results,
    const gchar *const *arg_terms,
    gchar ***out_results,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "GetSubsearchResultSet",
    g_variant_new ("(^as^as)",
                   arg_previous_results,
                   arg_terms),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(^as)",
                 out_results);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_get_result_metas:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_identifiers: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetResultMetas">GetResultMetas()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_call_get_result_metas_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_call_get_result_metas_sync() for the synchronous, blocking version of this method.
 */
void
cc_shell_search_provider2_call_get_result_metas (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_identifiers,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "GetResultMetas",
    g_variant_new ("(^as)",
                   arg_identifiers),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * cc_shell_search_provider2_call_get_result_metas_finish:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @out_metas: (out): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_call_get_result_metas().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with cc_shell_search_provider2_call_get_result_metas().
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_result_metas_finish (
    CcShellSearchProvider2 *proxy,
    GVariant **out_metas,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(@aa{sv})",
                 out_metas);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_get_result_metas_sync:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_identifiers: Argument to pass with the method invocation.
 * @out_metas: (out): Return location for return parameter or %NULL to ignore.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetResultMetas">GetResultMetas()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_call_get_result_metas() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_get_result_metas_sync (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_identifiers,
    GVariant **out_metas,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "GetResultMetas",
    g_variant_new ("(^as)",
                   arg_identifiers),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(@aa{sv})",
                 out_metas);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_activate_result:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_identifier: Argument to pass with the method invocation.
 * @arg_terms: Argument to pass with the method invocation.
 * @arg_timestamp: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.ActivateResult">ActivateResult()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_call_activate_result_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_call_activate_result_sync() for the synchronous, blocking version of this method.
 */
void
cc_shell_search_provider2_call_activate_result (
    CcShellSearchProvider2 *proxy,
    const gchar *arg_identifier,
    const gchar *const *arg_terms,
    guint arg_timestamp,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "ActivateResult",
    g_variant_new ("(s^asu)",
                   arg_identifier,
                   arg_terms,
                   arg_timestamp),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * cc_shell_search_provider2_call_activate_result_finish:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_call_activate_result().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with cc_shell_search_provider2_call_activate_result().
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_activate_result_finish (
    CcShellSearchProvider2 *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_activate_result_sync:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_identifier: Argument to pass with the method invocation.
 * @arg_terms: Argument to pass with the method invocation.
 * @arg_timestamp: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.ActivateResult">ActivateResult()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_call_activate_result() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_activate_result_sync (
    CcShellSearchProvider2 *proxy,
    const gchar *arg_identifier,
    const gchar *const *arg_terms,
    guint arg_timestamp,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "ActivateResult",
    g_variant_new ("(s^asu)",
                   arg_identifier,
                   arg_terms,
                   arg_timestamp),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_launch_search:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_terms: Argument to pass with the method invocation.
 * @arg_timestamp: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.LaunchSearch">LaunchSearch()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_call_launch_search_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_call_launch_search_sync() for the synchronous, blocking version of this method.
 */
void
cc_shell_search_provider2_call_launch_search (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_terms,
    guint arg_timestamp,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "LaunchSearch",
    g_variant_new ("(^asu)",
                   arg_terms,
                   arg_timestamp),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * cc_shell_search_provider2_call_launch_search_finish:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_call_launch_search().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with cc_shell_search_provider2_call_launch_search().
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_launch_search_finish (
    CcShellSearchProvider2 *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_call_launch_search_sync:
 * @proxy: A #CcShellSearchProvider2Proxy.
 * @arg_terms: Argument to pass with the method invocation.
 * @arg_timestamp: Argument to pass with the method invocation.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.LaunchSearch">LaunchSearch()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_call_launch_search() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeded, %FALSE if @error is set.
 */
gboolean
cc_shell_search_provider2_call_launch_search_sync (
    CcShellSearchProvider2 *proxy,
    const gchar *const *arg_terms,
    guint arg_timestamp,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "LaunchSearch",
    g_variant_new ("(^asu)",
                   arg_terms,
                   arg_timestamp),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * cc_shell_search_provider2_complete_get_initial_result_set:
 * @object: A #CcShellSearchProvider2.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @results: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetInitialResultSet">GetInitialResultSet()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
cc_shell_search_provider2_complete_get_initial_result_set (
    CcShellSearchProvider2 *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *results)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(^as)",
                   results));
}

/**
 * cc_shell_search_provider2_complete_get_subsearch_result_set:
 * @object: A #CcShellSearchProvider2.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @results: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetSubsearchResultSet">GetSubsearchResultSet()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
cc_shell_search_provider2_complete_get_subsearch_result_set (
    CcShellSearchProvider2 *object,
    GDBusMethodInvocation *invocation,
    const gchar *const *results)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(^as)",
                   results));
}

/**
 * cc_shell_search_provider2_complete_get_result_metas:
 * @object: A #CcShellSearchProvider2.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @metas: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.GetResultMetas">GetResultMetas()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
cc_shell_search_provider2_complete_get_result_metas (
    CcShellSearchProvider2 *object,
    GDBusMethodInvocation *invocation,
    GVariant *metas)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(@aa{sv})",
                   metas));
}

/**
 * cc_shell_search_provider2_complete_activate_result:
 * @object: A #CcShellSearchProvider2.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.ActivateResult">ActivateResult()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
cc_shell_search_provider2_complete_activate_result (
    CcShellSearchProvider2 *object,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * cc_shell_search_provider2_complete_launch_search:
 * @object: A #CcShellSearchProvider2.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-gnome-Shell-SearchProvider2.LaunchSearch">LaunchSearch()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
cc_shell_search_provider2_complete_launch_search (
    CcShellSearchProvider2 *object,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/* ------------------------------------------------------------------------ */

/**
 * CcShellSearchProvider2Proxy:
 *
 * The #CcShellSearchProvider2Proxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * CcShellSearchProvider2ProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #CcShellSearchProvider2Proxy.
 */

struct _CcShellSearchProvider2ProxyPrivate
{
  GData *qdata;
};

static void cc_shell_search_provider2_proxy_iface_init (CcShellSearchProvider2Iface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (CcShellSearchProvider2Proxy, cc_shell_search_provider2_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (CcShellSearchProvider2Proxy)
                         G_IMPLEMENT_INTERFACE (CC_TYPE_SHELL_SEARCH_PROVIDER2, cc_shell_search_provider2_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (CcShellSearchProvider2Proxy, cc_shell_search_provider2_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (CC_TYPE_SHELL_SEARCH_PROVIDER2, cc_shell_search_provider2_proxy_iface_init))

#endif
static void
cc_shell_search_provider2_proxy_finalize (GObject *object)
{
  CcShellSearchProvider2Proxy *proxy = CC_SHELL_SEARCH_PROVIDER2_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (cc_shell_search_provider2_proxy_parent_class)->finalize (object);
}

static void
cc_shell_search_provider2_proxy_get_property (GObject      *object,
  guint         prop_id,
  GValue       *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
cc_shell_search_provider2_proxy_set_property (GObject      *object,
  guint         prop_id,
  const GValue *value,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
cc_shell_search_provider2_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], CC_TYPE_SHELL_SEARCH_PROVIDER2);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, CC_TYPE_SHELL_SEARCH_PROVIDER2);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
cc_shell_search_provider2_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  CcShellSearchProvider2Proxy *proxy = CC_SHELL_SEARCH_PROVIDER2_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static void
cc_shell_search_provider2_proxy_init (CcShellSearchProvider2Proxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = cc_shell_search_provider2_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, CC_TYPE_SHELL_SEARCH_PROVIDER2_PROXY, CcShellSearchProvider2ProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), cc_shell_search_provider2_interface_info ());
}

static void
cc_shell_search_provider2_proxy_class_init (CcShellSearchProvider2ProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = cc_shell_search_provider2_proxy_finalize;
  gobject_class->get_property = cc_shell_search_provider2_proxy_get_property;
  gobject_class->set_property = cc_shell_search_provider2_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = cc_shell_search_provider2_proxy_g_signal;
  proxy_class->g_properties_changed = cc_shell_search_provider2_proxy_g_properties_changed;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (CcShellSearchProvider2ProxyPrivate));
#endif
}

static void
cc_shell_search_provider2_proxy_iface_init (CcShellSearchProvider2Iface *iface)
{
}

/**
 * cc_shell_search_provider2_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (allow-none): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_proxy_new_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
cc_shell_search_provider2_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (CC_TYPE_SHELL_SEARCH_PROVIDER2_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.gnome.Shell.SearchProvider2", NULL);
}

/**
 * cc_shell_search_provider2_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with cc_shell_search_provider2_proxy_new().
 *
 * Returns: (transfer full) (type CcShellSearchProvider2Proxy): The constructed proxy object or %NULL if @error is set.
 */
CcShellSearchProvider2 *
cc_shell_search_provider2_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return CC_SHELL_SEARCH_PROVIDER2 (ret);
  else
    return NULL;
}

/**
 * cc_shell_search_provider2_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (allow-none): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type CcShellSearchProvider2Proxy): The constructed proxy object or %NULL if @error is set.
 */
CcShellSearchProvider2 *
cc_shell_search_provider2_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (CC_TYPE_SHELL_SEARCH_PROVIDER2_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.gnome.Shell.SearchProvider2", NULL);
  if (ret != NULL)
    return CC_SHELL_SEARCH_PROVIDER2 (ret);
  else
    return NULL;
}


/**
 * cc_shell_search_provider2_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like cc_shell_search_provider2_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the <link linkend="g-main-context-push-thread-default">thread-default main loop</link> of the thread you are calling this method from.
 * You can then call cc_shell_search_provider2_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See cc_shell_search_provider2_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
cc_shell_search_provider2_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (CC_TYPE_SHELL_SEARCH_PROVIDER2_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.gnome.Shell.SearchProvider2", NULL);
}

/**
 * cc_shell_search_provider2_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to cc_shell_search_provider2_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with cc_shell_search_provider2_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type CcShellSearchProvider2Proxy): The constructed proxy object or %NULL if @error is set.
 */
CcShellSearchProvider2 *
cc_shell_search_provider2_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return CC_SHELL_SEARCH_PROVIDER2 (ret);
  else
    return NULL;
}

/**
 * cc_shell_search_provider2_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (allow-none): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like cc_shell_search_provider2_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See cc_shell_search_provider2_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type CcShellSearchProvider2Proxy): The constructed proxy object or %NULL if @error is set.
 */
CcShellSearchProvider2 *
cc_shell_search_provider2_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (CC_TYPE_SHELL_SEARCH_PROVIDER2_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.gnome.Shell.SearchProvider2", NULL);
  if (ret != NULL)
    return CC_SHELL_SEARCH_PROVIDER2 (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * CcShellSearchProvider2Skeleton:
 *
 * The #CcShellSearchProvider2Skeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * CcShellSearchProvider2SkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #CcShellSearchProvider2Skeleton.
 */

struct _CcShellSearchProvider2SkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_cc_shell_search_provider2_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  CcShellSearchProvider2Skeleton *skeleton = CC_SHELL_SEARCH_PROVIDER2_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], CC_TYPE_SHELL_SEARCH_PROVIDER2);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, CC_TYPE_SHELL_SEARCH_PROVIDER2);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_cc_shell_search_provider2_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  CcShellSearchProvider2Skeleton *skeleton = CC_SHELL_SEARCH_PROVIDER2_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_cc_shell_search_provider2_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  CcShellSearchProvider2Skeleton *skeleton = CC_SHELL_SEARCH_PROVIDER2_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_cc_shell_search_provider2_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _cc_shell_search_provider2_skeleton_vtable =
{
  _cc_shell_search_provider2_skeleton_handle_method_call,
  _cc_shell_search_provider2_skeleton_handle_get_property,
  _cc_shell_search_provider2_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
cc_shell_search_provider2_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return cc_shell_search_provider2_interface_info ();
}

static GDBusInterfaceVTable *
cc_shell_search_provider2_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_cc_shell_search_provider2_skeleton_vtable;
}

static GVariant *
cc_shell_search_provider2_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  CcShellSearchProvider2Skeleton *skeleton = CC_SHELL_SEARCH_PROVIDER2_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
  g_variant_builder_init (&builder, G_VARIANT_TYPE ("a{sv}"));
  if (_cc_shell_search_provider2_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _cc_shell_search_provider2_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _cc_shell_search_provider2_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _cc_shell_search_provider2_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.gnome.Shell.SearchProvider2", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static void
cc_shell_search_provider2_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton)
{
}

static void cc_shell_search_provider2_skeleton_iface_init (CcShellSearchProvider2Iface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (CcShellSearchProvider2Skeleton, cc_shell_search_provider2_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (CcShellSearchProvider2Skeleton)
                         G_IMPLEMENT_INTERFACE (CC_TYPE_SHELL_SEARCH_PROVIDER2, cc_shell_search_provider2_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (CcShellSearchProvider2Skeleton, cc_shell_search_provider2_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (CC_TYPE_SHELL_SEARCH_PROVIDER2, cc_shell_search_provider2_skeleton_iface_init))

#endif
static void
cc_shell_search_provider2_skeleton_finalize (GObject *object)
{
  CcShellSearchProvider2Skeleton *skeleton = CC_SHELL_SEARCH_PROVIDER2_SKELETON (object);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (cc_shell_search_provider2_skeleton_parent_class)->finalize (object);
}

static void
cc_shell_search_provider2_skeleton_init (CcShellSearchProvider2Skeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = cc_shell_search_provider2_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, CC_TYPE_SHELL_SEARCH_PROVIDER2_SKELETON, CcShellSearchProvider2SkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
}

static void
cc_shell_search_provider2_skeleton_class_init (CcShellSearchProvider2SkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = cc_shell_search_provider2_skeleton_finalize;

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = cc_shell_search_provider2_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = cc_shell_search_provider2_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = cc_shell_search_provider2_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = cc_shell_search_provider2_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (CcShellSearchProvider2SkeletonPrivate));
#endif
}

static void
cc_shell_search_provider2_skeleton_iface_init (CcShellSearchProvider2Iface *iface)
{
}

/**
 * cc_shell_search_provider2_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-gnome-Shell-SearchProvider2.top_of_page">org.gnome.Shell.SearchProvider2</link>.
 *
 * Returns: (transfer full) (type CcShellSearchProvider2Skeleton): The skeleton object.
 */
CcShellSearchProvider2 *
cc_shell_search_provider2_skeleton_new (void)
{
  return CC_SHELL_SEARCH_PROVIDER2 (g_object_new (CC_TYPE_SHELL_SEARCH_PROVIDER2_SKELETON, NULL));
}

